searchNodes=[{"doc":"Generates a .formatter.exs from a list of extensions, and writes it.","ref":"Mix.Tasks.Ash.Formatter.html","title":"Mix.Tasks.Ash.Formatter","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1.","ref":"Mix.Tasks.Ash.Formatter.html#run/1","title":"Mix.Tasks.Ash.Formatter.run/1","type":"function"},{"doc":"Quick LinksResource DocumentationDSL DocumentationCode API documentationIntroductionTraditional MVC Frameworks (Rails, Django, .Net, Phoenix, etc) leave it up to the user to build the glue between requests for data (HTTP requests in various forms as well as server-side domain logic) and their respective ORMs. In that space, there is an incredible amount of boilerplate code that must get written from scratch for each application (authentication, authorization, sorting, filtering, sideloading relationships, serialization, etc).Ash is an opinionated yet configurable framework designed to reduce boilerplate in an Elixir application. Ash does this by providing a layer of abstraction over your system's data layer(s) with Resources. It is designed to be used in conjunction with a phoenix application, or on its own.To riff on a famous JRR Tolkien quote, a Resourceis &quot;One Interface to rule them all, One Interface to find them&quot; and will become an indispensable place to define contracts for interacting with data throughout your application.To start using Ash, first declare your Resources using the Ash Resource DSL. You could technically stop there, and just leverage the Ash Elixir API to avoid writing boilerplate. More likely, you would use extensions like Ash.JsonApi or Ash.GraphQL with Phoenix to add external interfaces to those resources without having to write any extra code at all.Ash is an open-source project and draws inspiration from similar ideas in other frameworks and concepts. The goal of Ash is to lower the barrier to adopting and using Elixir and Phoenix, and in doing so help these amazing communities attract new developers, projects, and companies.Example Resourcedefmodule Post do use Ash.Resource actions do read :default create :default end attributes do attribute :name, :string end relationships do belongs_to :author, Author end endFor those looking to add ash extensions:see Ash.Dsl.Extension for adding configuration.If you are looking to write a new data source, also see the Ash.DataLayer documentation.If you are looking to write a new authorizer, see Ash.AuthorizerIf you are looking to write a &quot;front end&quot;, something powered by Ash resources, a guide on building those kinds of tools is in the works.","ref":"Ash.html","title":"Ash","type":"module"},{"doc":"Returns the action with the matching name and type on the resource","ref":"Ash.html#action/3","title":"Ash.action/3","type":"function"},{"doc":"","ref":"Ash.html#actions/1","title":"Ash.actions/1","type":"function"},{"doc":"Get an attribute name from the resource","ref":"Ash.html#attribute/2","title":"Ash.attribute/2","type":"function"},{"doc":"","ref":"Ash.html#attributes/1","title":"Ash.attributes/1","type":"function"},{"doc":"A list of authorizers to be used when accessing the resource","ref":"Ash.html#authorizers/1","title":"Ash.authorizers/1","type":"function"},{"doc":"The data layer of the resource, or nil if it does not have one","ref":"Ash.html#data_layer/1","title":"Ash.data_layer/1","type":"function"},{"doc":"","ref":"Ash.html#extensions/1","title":"Ash.extensions/1","type":"function"},{"doc":"","ref":"Ash.html#implements_behaviour?/2","title":"Ash.implements_behaviour?/2","type":"function"},{"doc":"Returns the primary action of a given type for a resource","ref":"Ash.html#primary_action/2","title":"Ash.primary_action/2","type":"function"},{"doc":"A list of field names corresponding to the primary key of a resource","ref":"Ash.html#primary_key/1","title":"Ash.primary_key/1","type":"function"},{"doc":"Gets a relationship by name from the resource","ref":"Ash.html#relationship/2","title":"Ash.relationship/2","type":"function"},{"doc":"","ref":"Ash.html#relationships/1","title":"Ash.relationships/1","type":"function"},{"doc":"","ref":"Ash.html#resource_module?/1","title":"Ash.resource_module?/1","type":"function"},{"doc":"","ref":"Ash.html#t:action/0","title":"Ash.action/0","type":"type"},{"doc":"","ref":"Ash.html#t:actor/0","title":"Ash.actor/0","type":"type"},{"doc":"","ref":"Ash.html#t:api/0","title":"Ash.api/0","type":"type"},{"doc":"","ref":"Ash.html#t:attribute/0","title":"Ash.attribute/0","type":"type"},{"doc":"","ref":"Ash.html#t:cardinality_many_relationship/0","title":"Ash.cardinality_many_relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:cardinality_one_relationship/0","title":"Ash.cardinality_one_relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:data_layer/0","title":"Ash.data_layer/0","type":"type"},{"doc":"","ref":"Ash.html#t:data_layer_query/0","title":"Ash.data_layer_query/0","type":"type"},{"doc":"","ref":"Ash.html#t:error/0","title":"Ash.error/0","type":"type"},{"doc":"","ref":"Ash.html#t:filter/0","title":"Ash.filter/0","type":"type"},{"doc":"","ref":"Ash.html#t:params/0","title":"Ash.params/0","type":"type"},{"doc":"","ref":"Ash.html#t:query/0","title":"Ash.query/0","type":"type"},{"doc":"","ref":"Ash.html#t:record/0","title":"Ash.record/0","type":"type"},{"doc":"","ref":"Ash.html#t:relationship/0","title":"Ash.relationship/0","type":"type"},{"doc":"","ref":"Ash.html#t:relationship_cardinality/0","title":"Ash.relationship_cardinality/0","type":"type"},{"doc":"","ref":"Ash.html#t:resource/0","title":"Ash.resource/0","type":"type"},{"doc":"","ref":"Ash.html#t:side_loads/0","title":"Ash.side_loads/0","type":"type"},{"doc":"","ref":"Ash.html#t:sort/0","title":"Ash.sort/0","type":"type"},{"doc":"An Api allows you to interact with your resources, and holds non-resource-specific configuration.Your Api can also house config that is not resource specific. Defining a resource won't do much for you. Once you have some resources defined, you include them in an Api like so:defmodule MyApp.Api do use Ash.Api resources do resource OneResource resource SecondResource endThen you can interact through that Api with the actions that those resources expose. For example: MyApp.Api.create(OneResource, %{attributes: %{name: &quot;thing&quot;}}), or MyApp.Api.read(query). Corresponding actions must be defined in your resources in order to call them through the Api.","ref":"Ash.Api.html","title":"Ash.Api","type":"behaviour"},{"doc":"Create a record:upsert? - If a conflict is found based on the primary key, the record is updated in the database (requires upsert support) The default value is false.:attributes - Changes to be applied to attribute values The default value is %{}.:relationships - Changes to be applied to relationship values The default value is %{}.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:create/2","title":"Ash.Api.create/2","type":"callback"},{"doc":"Create a record:upsert? - If a conflict is found based on the primary key, the record is updated in the database (requires upsert support) The default value is false.:attributes - Changes to be applied to attribute values The default value is %{}.:relationships - Changes to be applied to relationship values The default value is %{}.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:create!/2","title":"Ash.Api.create!/2","type":"callback"},{"doc":"Destroy a record:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:destroy/2","title":"Ash.Api.destroy/2","type":"callback"},{"doc":"Destroy a record:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:destroy!/2","title":"Ash.Api.destroy!/2","type":"callback"},{"doc":"Get a record by a primary key:side_load - Side loads to include in the query, same as you would pass to Ash.Query.side_load/2:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:get/3","title":"Ash.Api.get/3","type":"callback"},{"doc":"Get a record by a primary key:side_load - Side loads to include in the query, same as you would pass to Ash.Query.side_load/2:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:get!/3","title":"Ash.Api.get!/3","type":"callback"},{"doc":"Run a query on a resource:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:read/2","title":"Ash.Api.read/2","type":"callback"},{"doc":"Run a query on a resource:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:read!/2","title":"Ash.Api.read!/2","type":"callback"},{"doc":"Refetches a record from the database","ref":"Ash.Api.html#c:reload/1","title":"Ash.Api.reload/1","type":"callback"},{"doc":"Refetches a record from the database, raising on error.See reload/1.","ref":"Ash.Api.html#c:reload!/2","title":"Ash.Api.reload!/2","type":"callback"},{"doc":"","ref":"Ash.Api.html#resource/2","title":"Ash.Api.resource/2","type":"function"},{"doc":"","ref":"Ash.Api.html#resources/1","title":"Ash.Api.resources/1","type":"function"},{"doc":"Side load on already fetched records:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:side_load/2","title":"Ash.Api.side_load/2","type":"callback"},{"doc":"Side load on already fetched records:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:side_load!/2","title":"Ash.Api.side_load!/2","type":"callback"},{"doc":"Update a record:attributes - Changes to be applied to attribute values The default value is %{}.:relationships - Changes to be applied to relationship values The default value is %{}.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:update/2","title":"Ash.Api.update/2","type":"callback"},{"doc":"Update a record:attributes - Changes to be applied to attribute values The default value is %{}.:relationships - Changes to be applied to relationship values The default value is %{}.:verbose? - Log engine operations (very verbose?) The default value is false.:action - The action to use, either an Action struct or the name of the action:authorize? - If an actor is provided, authorization happens automatically. If not, this flag can be used to authorize with no user. The default value is false.:actor - If an actor is provided, it will be used in conjunction with the authorizers of a resource to authorize access","ref":"Ash.Api.html#c:update!/2","title":"Ash.Api.update!/2","type":"callback"},{"doc":"The built in resource DSL. The three core DSL components of a resource are:attributes - attributes/1relationships - relationships/1actions - actions/1","ref":"Ash.Dsl.html","title":"Ash.Dsl","type":"module"},{"doc":"A section for declaring resource actions.All manipulation of data through the underlying data layer happens through actions. There are four types of action: create, read, update, and destroy. You may recognize these from the acronym CRUD. You can have multiple actions of the same type, as long as they have different names. This is the primary mechanism for customizing your resources to conform to your business logic. It is normal and expected to have multiple actions of each type in a large application.If you have multiple actions of the same type, one of them must be designated as the primary action for that type, via: primary?: true. This tells the ash what to do if an action of that type is requested, but no specific action name is given.Constructorscreate - Ash.Dsl.Createread - Ash.Dsl.Readupdate - Ash.Dsl.Updatedestroy - Ash.Dsl.Destroy","ref":"Ash.Dsl.html#actions/1","title":"Ash.Dsl.actions/1","type":"macro"},{"doc":"A section for declaring attributes on the resource.Attributes are fields on an instance of a resource. The two required pieces of knowledge are the field name, and the type.Constructorsattribute - Ash.Dsl.Attributecreate_timestamp - Ash.Dsl.CreateTimestampupdate_timestamp - Ash.Dsl.UpdateTimestamp","ref":"Ash.Dsl.html#attributes/1","title":"Ash.Dsl.attributes/1","type":"macro"},{"doc":"A section for declaring relationships on the resource.Relationships are a core component of resource oriented design. Many components of Ash will use these relationships. A simple use case is side_loading (done via the Ash.Query.side_load/2).Constructorshas_one - Ash.Dsl.HasOnehas_many - Ash.Dsl.HasManymany_to_many - Ash.Dsl.ManyToManybelongs_to - Ash.Dsl.BelongsTo","ref":"Ash.Dsl.html#relationships/1","title":"Ash.Dsl.relationships/1","type":"macro"},{"doc":"Resource-wide configurationOptions:description","ref":"Ash.Dsl.html#resource/1","title":"Ash.Dsl.resource/1","type":"macro"},{"doc":"Utilties around constructing/manipulating ash queries.Ash queries are used for read actions and side loads, and ultimately map to queries to a resource's data layer.","ref":"Ash.Query.html","title":"Ash.Query","type":"module"},{"doc":"","ref":"Ash.Query.html#do_validate_side_load/3","title":"Ash.Query.do_validate_side_load/3","type":"function"},{"doc":"","ref":"Ash.Query.html#filter/2","title":"Ash.Query.filter/2","type":"function"},{"doc":"","ref":"Ash.Query.html#limit/2","title":"Ash.Query.limit/2","type":"function"},{"doc":"","ref":"Ash.Query.html#merge_side_load/2","title":"Ash.Query.merge_side_load/2","type":"function"},{"doc":"","ref":"Ash.Query.html#offset/2","title":"Ash.Query.offset/2","type":"function"},{"doc":"","ref":"Ash.Query.html#reject/2","title":"Ash.Query.reject/2","type":"function"},{"doc":"","ref":"Ash.Query.html#side_load/2","title":"Ash.Query.side_load/2","type":"function"},{"doc":"","ref":"Ash.Query.html#sort/2","title":"Ash.Query.sort/2","type":"function"},{"doc":"","ref":"Ash.Query.html#unset/2","title":"Ash.Query.unset/2","type":"function"},{"doc":"","ref":"Ash.Query.html#validate_side_load/3","title":"Ash.Query.validate_side_load/3","type":"function"},{"doc":"","ref":"Ash.Query.html#t:t/0","title":"Ash.Query.t/0","type":"type"},{"doc":"A resource is a static definition of an entity in your system.Resource DSL documentation: Ash.DslFor more information on the resource DSL, see Ash.Dsl","ref":"Ash.Resource.html","title":"Ash.Resource","type":"module"},{"doc":"This behaviour is a superset of the Ecto.Type behavior, that also contains api level information, like what kinds of filters are allowed. Eventually, this may be used for composite types or serialization.Much better to use Ash.Type than to say @behaviour Ash.Type and define everything yourself.","ref":"Ash.Type.html","title":"Ash.Type","type":"behaviour"},{"doc":"Returns true if the value is a builtin type or adopts the Ash.Type behaviour","ref":"Ash.Type.html#ash_type?/1","title":"Ash.Type.ash_type?/1","type":"function"},{"doc":"A list of the built in type names","ref":"Ash.Type.html#builtins/0","title":"Ash.Type.builtins/0","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_input/1","title":"Ash.Type.cast_input/1","type":"callback"},{"doc":"Casts input (e.g. unknown) data to an instance of the type, or errorsMaps to Ecto.Type.cast/2","ref":"Ash.Type.html#cast_input/2","title":"Ash.Type.cast_input/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:cast_stored/1","title":"Ash.Type.cast_stored/1","type":"callback"},{"doc":"Casts a value from the data store to an instance of the type, or errorsMaps to Ecto.Type.load/2","ref":"Ash.Type.html#cast_stored/2","title":"Ash.Type.cast_stored/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:describe/0","title":"Ash.Type.describe/0","type":"callback"},{"doc":"","ref":"Ash.Type.html#c:dump_to_native/1","title":"Ash.Type.dump_to_native/1","type":"callback"},{"doc":"Casts a value from the Elixir type to a value that the data store can persistMaps to Ecto.Type.dump/2","ref":"Ash.Type.html#dump_to_native/2","title":"Ash.Type.dump_to_native/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:ecto_type/0","title":"Ash.Type.ecto_type/0","type":"callback"},{"doc":"Returns the ecto compatible type for an Ash.Type.If you use Ash.Type, this is created for you. For builtin types this may return a corresponding ecto builtin type (atom)","ref":"Ash.Type.html#ecto_type/1","title":"Ash.Type.ecto_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:equal?/2","title":"Ash.Type.equal?/2","type":"callback"},{"doc":"Determines if two values of a given type are equal.Maps to Ecto.Type.equal?/3","ref":"Ash.Type.html#equal?/3","title":"Ash.Type.equal?/3","type":"function"},{"doc":"","ref":"Ash.Type.html#get_type/1","title":"Ash.Type.get_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:sortable?/1","title":"Ash.Type.sortable?/1","type":"callback"},{"doc":"Determines whether or not this value can be sorted.","ref":"Ash.Type.html#sortable?/2","title":"Ash.Type.sortable?/2","type":"function"},{"doc":"","ref":"Ash.Type.html#c:storage_type/0","title":"Ash.Type.storage_type/0","type":"callback"},{"doc":"Returns the underlying storage type (the underlying type of the ecto type of the ash type)","ref":"Ash.Type.html#storage_type/1","title":"Ash.Type.storage_type/1","type":"function"},{"doc":"","ref":"Ash.Type.html#c:supported_filter_types/1","title":"Ash.Type.supported_filter_types/1","type":"callback"},{"doc":"","ref":"Ash.Type.html#supports_filter?/4","title":"Ash.Type.supports_filter?/4","type":"function"},{"doc":"","ref":"Ash.Type.html#t:t/0","title":"Ash.Type.t/0","type":"type"},{"doc":"A type used for storing atoms.For safety reasons, it uses String.to_existing_atom/1, which means that the atom should exist in your application before reading a record with that atom.","ref":"Ash.Type.Atom.html","title":"Ash.Type.Atom","type":"module"},{"doc":"Stores a raw elixir term in the database","ref":"Ash.Type.Term.html","title":"Ash.Type.Term","type":"module"},{"doc":"The interface for being an ash data layer.Typically this will be provided by an extension, but you could implement one yourself and add it to your resource with @data_layer YourDataLayerThis is a large behaviour, and this capability is not complete, but the idea is to have a large amount of optional callbacks, and use the can?/2 callback to ensure that the engine only ever tries to interact with the data layer in ways that it supports.","ref":"Ash.DataLayer.html","title":"Ash.DataLayer","type":"behaviour"},{"doc":"","ref":"Ash.DataLayer.html#can?/2","title":"Ash.DataLayer.can?/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:can?/2","title":"Ash.DataLayer.can?/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:can_query_async?/1","title":"Ash.DataLayer.can_query_async?/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#create/2","title":"Ash.DataLayer.create/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:create/2","title":"Ash.DataLayer.create/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:custom_filters/1","title":"Ash.DataLayer.custom_filters/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#c:destroy/1","title":"Ash.DataLayer.destroy/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#filter/3","title":"Ash.DataLayer.filter/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:filter/3","title":"Ash.DataLayer.filter/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#limit/3","title":"Ash.DataLayer.limit/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:limit/3","title":"Ash.DataLayer.limit/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#offset/3","title":"Ash.DataLayer.offset/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:offset/3","title":"Ash.DataLayer.offset/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:resource_to_query/1","title":"Ash.DataLayer.resource_to_query/1","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#run_query/2","title":"Ash.DataLayer.run_query/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:run_query/2","title":"Ash.DataLayer.run_query/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#sort/3","title":"Ash.DataLayer.sort/3","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:sort/3","title":"Ash.DataLayer.sort/3","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#transact/2","title":"Ash.DataLayer.transact/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:transaction/2","title":"Ash.DataLayer.transaction/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#update/2","title":"Ash.DataLayer.update/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:update/2","title":"Ash.DataLayer.update/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#upsert/2","title":"Ash.DataLayer.upsert/2","type":"function"},{"doc":"","ref":"Ash.DataLayer.html#c:upsert/2","title":"Ash.DataLayer.upsert/2","type":"callback"},{"doc":"","ref":"Ash.DataLayer.html#t:feature/0","title":"Ash.DataLayer.feature/0","type":"type"},{"doc":"","ref":"Ash.DataLayer.html#t:filter_type/0","title":"Ash.DataLayer.filter_type/0","type":"type"},{"doc":"An ETS (Erlang Term Storage) backed Ash Datalayer, for testing.This is used for testing. Do not use this data layer in production","ref":"Ash.DataLayer.Ets.html","title":"Ash.DataLayer.Ets","type":"module"},{"doc":"A section for configuring the ets data layerOptions:private? - The default value is false.","ref":"Ash.DataLayer.Ets.html#ets/1","title":"Ash.DataLayer.Ets.ets/1","type":"macro"},{"doc":"","ref":"Ash.DataLayer.Ets.html#private?/1","title":"Ash.DataLayer.Ets.private?/1","type":"function"},{"doc":"The interface for an ash authorizerThese will typically be implemented by an extension, but a custom one can be implemented by defining a module that adopts this behaviour and using @authorizers YourAuthorizer to your resource.","ref":"Ash.Authorizer.html","title":"Ash.Authorizer","type":"behaviour"},{"doc":"","ref":"Ash.Authorizer.html#c:check/2","title":"Ash.Authorizer.check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check/3","title":"Ash.Authorizer.check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:check_context/1","title":"Ash.Authorizer.check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#check_context/2","title":"Ash.Authorizer.check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:initial_state/4","title":"Ash.Authorizer.initial_state/4","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#initial_state/5","title":"Ash.Authorizer.initial_state/5","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check/2","title":"Ash.Authorizer.strict_check/2","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check/3","title":"Ash.Authorizer.strict_check/3","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#c:strict_check_context/1","title":"Ash.Authorizer.strict_check_context/1","type":"callback"},{"doc":"","ref":"Ash.Authorizer.html#strict_check_context/2","title":"Ash.Authorizer.strict_check_context/2","type":"function"},{"doc":"","ref":"Ash.Authorizer.html#t:context/0","title":"Ash.Authorizer.context/0","type":"type"},{"doc":"","ref":"Ash.Authorizer.html#t:state/0","title":"Ash.Authorizer.state/0","type":"type"},{"doc":"Declares a DSL entity.A dsl entity represents a dsl constructor who's resulting value is a struct. This lets the user create complex objects with arbitrary(mostly) validation rules.The lifecycle of creating entities is complex, happening as Elixir is compiling the modules in question. Some of the patterns around validating/transforming entities have not yet solidified. If you aren't careful and don't follow the guidelines listed here, you can have subtle and strange bugs during compilation. Anything not isolated to simple value validations should be done in transformers. See Ash.Dsl.Transformer.An entity has a target indicating which struct will ultimately be built. An entity also has a schema. This schema is used for documentation, and the options are validated against it before continuing on with the DSL.To create positional arguments to the builder, use args. The values provided to args need to be in the provided schema as well. They will be positional arguments in the same order that they are provided in the args key.auto_set_fields will set the provided values into the produced struct (they do not need to be included in the schema).transform is a function that takes a created struct and can alter it. This happens immediately after handling the DSL options, and can be useful for setting field values on a struct based on other values in that struct. If you need things that aren't contained in that struct, use an Ash.Dsl.Transformer.entities allows you to specify a keyword list of nested entities. Nested entities are stored on the struct in the corresponding key, and are used in the same way entities are otherwise.For a full example, see Ash.Dsl.Extension.","ref":"Ash.Dsl.Entity.html","title":"Ash.Dsl.Entity","type":"module"},{"doc":"","ref":"Ash.Dsl.Entity.html#build/3","title":"Ash.Dsl.Entity.build/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Entity.html#describe/2","title":"Ash.Dsl.Entity.describe/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Entity.html#validate/2","title":"Ash.Dsl.Entity.validate/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Entity.html#t:t/0","title":"Ash.Dsl.Entity.t/0","type":"type"},{"doc":"An extension to the Ash DSL.This allows configuring custom DSL components, whos configurations can then be read back.The example at the bottom shows how you might build a (not very contextually relevant) DSL extension that would be used like so:defmodule MyApp.MyResource do use Ash.Resource, extensions: [MyApp.CarExtension] cars do car :mazda, &quot;6&quot;, trim: :touring car :toyota, &quot;corolla&quot; end endFor (a not very contextually relevant) example:defmodule MyApp.CarExtension do @car_schema [ make: [ type: :atom, required: true, doc: &quot;The make of the car&quot; ], model: [ type: :atom, required: true, doc: &quot;The model of the car&quot; ], type: [ type: :atom, required: true, doc: &quot;The type of the car&quot;, default: :sedan ] ] @car %Ash.Dsl.Entity{ name: :car, describe: &quot;Adds a car&quot;, examples: [ &quot;car :mazda, &quot;6&quot;&quot; ], target: MyApp.Car, args: [:make, :model], schema: @car_schema } @cars %Ash.Dsl.Section{ name: :cars, # The DSL constructor will be `cars` describe: &quot;&quot;&quot; Configure what cars are available. More, deeper explanation. Always have a short one liner explanation, an empty line, and then a longer explanation. &quot;&quot;&quot;, entities: [ @car # See `Ash.Dsl.Entity` docs ], schema: [ default_manufacturer: [ type: :atom, doc: &quot;The default manufacturer&quot; ] ] } use Ash.Dsl.Extension, sections: [@cars] endOften, we will need to do complex validation/validate based on the configuration of other resources. Due to the nature of building compile time DSLs, there are many restrictions around that process. To support these complex use cases, extensions can include transformers which can validate/transform the DSL state after all basic sections/entities have been created. See Ash.Dsl.Transformer for more information. Transformers are provided as an option to use, like so:use Ash.Dsl.Extension, sections: [@cars], transformers: [ MyApp.Transformers.ValidateNoOverlappingMakesAndModels ]To expose the configuration of your DSL, define functions that use the helpers like get_entities/2 and get_opt/3. For example:defmodule MyApp.Cars do def cars(resource) do Ash.Dsl.Extension.get_entities(resource, [:cars]) end end MyApp.Cars.cars(MyResource) # [%MyApp.Car{...}, %MyApp.Car{...}]","ref":"Ash.Dsl.Extension.html","title":"Ash.Dsl.Extension","type":"behaviour"},{"doc":"Get the entities configured for a given section","ref":"Ash.Dsl.Extension.html#get_entities/2","title":"Ash.Dsl.Extension.get_entities/2","type":"function"},{"doc":"Get an option value for a section at a given path","ref":"Ash.Dsl.Extension.html#get_opt/3","title":"Ash.Dsl.Extension.get_opt/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Extension.html#import_mods/1","title":"Ash.Dsl.Extension.import_mods/1","type":"macro"},{"doc":"","ref":"Ash.Dsl.Extension.html#c:sections/0","title":"Ash.Dsl.Extension.sections/0","type":"callback"},{"doc":"","ref":"Ash.Dsl.Extension.html#c:transformers/0","title":"Ash.Dsl.Extension.transformers/0","type":"callback"},{"doc":"","ref":"Ash.Dsl.Extension.html#unimport_mods/1","title":"Ash.Dsl.Extension.unimport_mods/1","type":"macro"},{"doc":"Declares a DSL section.A dsl section allows you to organize related configurations. All extensions configure sections, they cannot add DSL builders to the top level. This keeps things organized, and concerns separated.A section may have nested sections, which will be configured the same as other sections. Getting the options/entities of a section is done by providing a path, so you would use the nested path to retrieve that configuration. See Ash.Dsl.Extension.get_entities/2 and Ash.Dsl.Extension.get_opt/3.A section may have entities, which are constructors that produce instances of structs. For more on entities, see Ash.Dsl.Entity.A section may also have a schema, which is a NimbleOptions schema. Ash will produce builders for those options, so that they may be configured. They are retrived with Ash.Dsl.Extension.get_opt/3.For a full example, see Ash.Dsl.Extension.","ref":"Ash.Dsl.Section.html","title":"Ash.Dsl.Section","type":"module"},{"doc":"","ref":"Ash.Dsl.Section.html#describe/3","title":"Ash.Dsl.Section.describe/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Section.html#t:t/0","title":"Ash.Dsl.Section.t/0","type":"type"},{"doc":"Creates the attribute for belongs_to relationships that have define_field?: true","ref":"Ash.Resource.Transformers.BelongsToAttribute.html","title":"Ash.Resource.Transformers.BelongsToAttribute","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#after?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#before?/1","title":"Ash.Resource.Transformers.BelongsToAttribute.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.BelongsToAttribute.html#transform/2","title":"Ash.Resource.Transformers.BelongsToAttribute.transform/2","type":"function"},{"doc":"Sets the default source_field for belongs_to attributes","ref":"Ash.Resource.Transformers.BelongsToSourceField.html","title":"Ash.Resource.Transformers.BelongsToSourceField","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#after?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#before?/1","title":"Ash.Resource.Transformers.BelongsToSourceField.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.BelongsToSourceField.html#transform/2","title":"Ash.Resource.Transformers.BelongsToSourceField.transform/2","type":"function"},{"doc":"Validates the primary key of a resource, and caches it in :persistent_term for fast access","ref":"Ash.Resource.Transformers.CachePrimaryKey.html","title":"Ash.Resource.Transformers.CachePrimaryKey","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#after?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#before?/1","title":"Ash.Resource.Transformers.CachePrimaryKey.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.CachePrimaryKey.html#transform/2","title":"Ash.Resource.Transformers.CachePrimaryKey.transform/2","type":"function"},{"doc":"Creates an automatically named has_many relationship for each many_to_many.This will likely not be around for long, as our logic around many to many relationships will update soon.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html","title":"Ash.Resource.Transformers.CreateJoinRelationship","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#after?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#before?/1","title":"Ash.Resource.Transformers.CreateJoinRelationship.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.CreateJoinRelationship.html#transform/2","title":"Ash.Resource.Transformers.CreateJoinRelationship.transform/2","type":"function"},{"doc":"Creates/validates the primary action configurationIf only one action of a given type is defined, it is marked as primary. If multiple exist, and one is not primary, this results in an error.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html","title":"Ash.Resource.Transformers.SetPrimaryActions","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#after?/1","title":"Ash.Resource.Transformers.SetPrimaryActions.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#before?/1","title":"Ash.Resource.Transformers.SetPrimaryActions.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.SetPrimaryActions.html#transform/2","title":"Ash.Resource.Transformers.SetPrimaryActions.transform/2","type":"function"},{"doc":"Sets the source key on relationships to be the resource they were defined on","ref":"Ash.Resource.Transformers.SetRelationshipSource.html","title":"Ash.Resource.Transformers.SetRelationshipSource","type":"module"},{"doc":"Callback implementation for Ash.Dsl.Transformer.after?/1.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#after?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.after?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.before?/1.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#before?/1","title":"Ash.Resource.Transformers.SetRelationshipSource.before?/1","type":"function"},{"doc":"Callback implementation for Ash.Dsl.Transformer.transform/2.","ref":"Ash.Resource.Transformers.SetRelationshipSource.html#transform/2","title":"Ash.Resource.Transformers.SetRelationshipSource.transform/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Attribute.html","title":"Ash.Dsl.Attribute","type":"module"},{"doc":"Declares an attribute on the resourceType can be either a built in type (see Ash.Type) for more, or a module implementing the Ash.Type behaviour.Examplesattribute :first_name, :string, primary_key?: trueArguments:name - The name of the attribute.:type - The type of the attribute.Options:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer The default value is false.:writable? - Whether or not the value can be written to The default value is true.:update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used.:default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used.","ref":"Ash.Dsl.Attribute.html#attribute/3","title":"Ash.Dsl.Attribute.attribute/3","type":"macro"},{"doc":"","ref":"Ash.Dsl.BelongsTo.html","title":"Ash.Dsl.BelongsTo","type":"module"},{"doc":"Declares a belongs_to relationship. In a relational database, the foreign key would be on the source table.This creates a field on the resource with the corresponding name and type, unless define_field?: false is provided.Examples# In a resource called `Word` belongs_to :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:primary_key? - Whether this field is, or is part of, the primary key of a resource. The default value is false.:define_field? - If set to false a field is not created on the resource for this relationship, and one must be manually added in attributes. The default value is true.:field_type - The field type of the automatically created field. The default value is :uuid.:destination_field - false The field on the related resource that should match the source_field on this resource. The default value is :id.:source_field - The field on this resource that should match the destination_field on the related resource. - Defaults to &lt;name&gt;_id:reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource.","ref":"Ash.Dsl.BelongsTo.html#belongs_to/3","title":"Ash.Dsl.BelongsTo.belongs_to/3","type":"macro"},{"doc":"","ref":"Ash.Dsl.Create.html","title":"Ash.Dsl.Create","type":"module"},{"doc":"Declares a create action. For calling this action, see the Ash.Api documentation.Examplescreate :register, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Dsl.Create.html#create/2","title":"Ash.Dsl.Create.create/2","type":"macro"},{"doc":"","ref":"Ash.Dsl.CreateTimestamp.html","title":"Ash.Dsl.CreateTimestamp","type":"module"},{"doc":"Declares a non-writable attribute with a create default of &amp;DateTime.utc_now/0Examplescreate_timestamp :inserted_atArguments:name - The name of the attribute.Options:type - false The type of the attribute. The default value is :utc_datetime.:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer The default value is false.:writable? - false Whether or not the value can be written to The default value is false.:update_default - A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used.:default - false A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used. The default value is &amp;DateTime.utc_now/0.","ref":"Ash.Dsl.CreateTimestamp.html#create_timestamp/2","title":"Ash.Dsl.CreateTimestamp.create_timestamp/2","type":"macro"},{"doc":"","ref":"Ash.Dsl.Destroy.html","title":"Ash.Dsl.Destroy","type":"module"},{"doc":"Declares a destroy action. For calling this action, see the Ash.Api documentation.Examplesdestroy :soft_delete, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Dsl.Destroy.html#destroy/2","title":"Ash.Dsl.Destroy.destroy/2","type":"macro"},{"doc":"","ref":"Ash.Dsl.HasMany.html","title":"Ash.Dsl.HasMany","type":"module"},{"doc":"Declares a has_many relationship. There can be any number of related entities.Examples# In a resource called `Word` has_many :definitions, DictionaryDefinition, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:destination_field - Required. The field on the related resource that should match the source_field on this resource.:source_field - false The field on this resource that should match the destination_field on the related resource. The default value is :id.:reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource.","ref":"Ash.Dsl.HasMany.html#has_many/3","title":"Ash.Dsl.HasMany.has_many/3","type":"macro"},{"doc":"","ref":"Ash.Dsl.HasOne.html","title":"Ash.Dsl.HasOne","type":"module"},{"doc":"Declares a has_one relationship. In a relationsal database, the foreign key would be on the other table.Generally speaking, a has_one also implies that the destination table is unique on that foreign key.Examples# In a resource called `Word` has_one :dictionary_entry, DictionaryEntry, source_field: :text, destination_field: :word_text Arguments:name - The name of the relationship:destination - The destination resourceOptions:destination_field - Required. The field on the related resource that should match the source_field on this resource.:source_field - false The field on this resource that should match the destination_field on the related resource. The default value is :id.:reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource.","ref":"Ash.Dsl.HasOne.html#has_one/3","title":"Ash.Dsl.HasOne.has_one/3","type":"macro"},{"doc":"","ref":"Ash.Dsl.ManyToMany.html","title":"Ash.Dsl.ManyToMany","type":"module"},{"doc":"Declares a many_to_many relationship. Many to many relationships require a join table.A join table is typically a table who's primary key consists of one foreign key to each resource.Examples# In a resource called `Word` many_to_many :books, Book, through: BookWord, source_field: :text, source_field_on_join_table: :word_text, destination_field: :id, destination_field_on_join_table: :book_id Arguments:name - The name of the relationship:destination - The destination resourceOptions:source_field_on_join_table - Required. The field on the join table that should line up with source_field on this resource.:destination_field_on_join_table - Required. The field on the join table that should line up with destination_field on the related resource. Default: [relationshihp_name]_id:through - Required. The resource to use as the join resource.:destination_field - false The field on the related resource that should match the source_field on this resource. The default value is :id.:source_field - false The field on this resource that should match the destination_field on the related resource. The default value is :id.:reverse_relationship - A requirement for side loading data. Must be the name of an inverse relationship on the destination resource.","ref":"Ash.Dsl.ManyToMany.html#many_to_many/3","title":"Ash.Dsl.ManyToMany.many_to_many/3","type":"macro"},{"doc":"","ref":"Ash.Dsl.Read.html","title":"Ash.Dsl.Read","type":"module"},{"doc":"Declares a read action. For calling this action, see the Ash.Api documentation.Examplesread :read_all, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Dsl.Read.html#read/2","title":"Ash.Dsl.Read.read/2","type":"macro"},{"doc":"A transformer manipulates and/or validates the entire DSL state of a resource.It's transform/2 takes a map, which is just the values/configurations at each point of the DSL. Don't manipulate it directly, if possible, instead use functions like get_entities/3 and replace_entity/5 to manipulate it.Use the after?/1 and before?/1 callbacks to ensure that your transformer runs either before or after some other transformer.The pattern for requesting information from other modules that use the DSL and are also currently compiling has not yet been determined. If you have that requirement you will need extra utilities to ensure that some other DSL based module has either completed or reached a certain point in its transformers. These utilities have not yet been written.","ref":"Ash.Dsl.Transformer.html","title":"Ash.Dsl.Transformer","type":"behaviour"},{"doc":"","ref":"Ash.Dsl.Transformer.html#add_entity/4","title":"Ash.Dsl.Transformer.add_entity/4","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:after?/1","title":"Ash.Dsl.Transformer.after?/1","type":"callback"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:before?/1","title":"Ash.Dsl.Transformer.before?/1","type":"callback"},{"doc":"","ref":"Ash.Dsl.Transformer.html#build_before_after_list/3","title":"Ash.Dsl.Transformer.build_before_after_list/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#build_entity/4","title":"Ash.Dsl.Transformer.build_entity/4","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#compare/2","title":"Ash.Dsl.Transformer.compare/2","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#get_entities/3","title":"Ash.Dsl.Transformer.get_entities/3","type":"function"},{"doc":"Store a value in a special persistent term key, that will be copied to the runtime","ref":"Ash.Dsl.Transformer.html#persist_to_runtime/3","title":"Ash.Dsl.Transformer.persist_to_runtime/3","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#replace_entity/5","title":"Ash.Dsl.Transformer.replace_entity/5","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#sort/1","title":"Ash.Dsl.Transformer.sort/1","type":"function"},{"doc":"","ref":"Ash.Dsl.Transformer.html#c:transform/2","title":"Ash.Dsl.Transformer.transform/2","type":"callback"},{"doc":"","ref":"Ash.Dsl.Update.html","title":"Ash.Dsl.Update","type":"module"},{"doc":"Declares a update action. For calling this action, see the Ash.Api documentation.Examplesupdate :flag_for_review, primary?: trueArguments:name - The name of the actionOptions:primary? - Whether or not this action should be used when no action is specified by the caller. The default value is false.","ref":"Ash.Dsl.Update.html#update/2","title":"Ash.Dsl.Update.update/2","type":"macro"},{"doc":"","ref":"Ash.Dsl.UpdateTimestamp.html","title":"Ash.Dsl.UpdateTimestamp","type":"module"},{"doc":"Declares a non-writable attribute with a create and update default of &amp;DateTime.utc_now/0Examplesupdate_timestamp :inserted_atArguments:name - The name of the attribute.Options:type - false The type of the attribute. The default value is :utc_datetime.:primary_key? - Whether or not the attribute is part of the primary key (one or more fields that uniquely identify a resource) The default value is false.:allow_nil? - Whether or not the attribute can be set to nil The default value is true.:generated? - Whether or not the value may be generated by the data layer The default value is false.:writable? - false Whether or not the value can be written to The default value is false.:update_default - false A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on update, this value is used. The default value is &amp;DateTime.utc_now/0.:default - false A zero argument function, an {mod, fun, args} triple or {:constant, value}. If no value is provided for the attribute on create, this value is used. The default value is &amp;DateTime.utc_now/0.","ref":"Ash.Dsl.UpdateTimestamp.html#update_timestamp/2","title":"Ash.Dsl.UpdateTimestamp.update_timestamp/2","type":"macro"},{"doc":"A small DSL for declaring APIsApis are the entrypoints for working with your resources.resources - resources/1","ref":"Ash.Api.Dsl.html","title":"Ash.Api.Dsl","type":"module"},{"doc":"List the resources present in this APIConstructorsresource - Ash.Api.Dsl.Resource","ref":"Ash.Api.Dsl.html#resources/1","title":"Ash.Api.Dsl.resources/1","type":"macro"},{"doc":"","ref":"Ash.Api.Dsl.Resource.html","title":"Ash.Api.Dsl.Resource","type":"module"},{"doc":"A reference to a resourceExamplesresource MyApp.UserArguments:resource - The module of the resource","ref":"Ash.Api.Dsl.Resource.html#resource/2","title":"Ash.Api.Dsl.Resource.resource/2","type":"macro"},{"doc":"Used when api's DSL is incorrectly configured.","ref":"Ash.Error.ApiDslError.html","title":"Ash.Error.ApiDslError","type":"exception"},{"doc":"Used when an invalid value is provided for a change","ref":"Ash.Error.Changes.InvalidValue.html","title":"Ash.Error.Changes.InvalidValue","type":"exception"},{"doc":"Used when a change fails for an unknown reason","ref":"Ash.Error.Changes.UnknownError.html","title":"Ash.Error.Changes.UnknownError","type":"exception"},{"doc":"Used when an invalid value is provided for a filter","ref":"Ash.Error.Filter.InvalidFilterValue.html","title":"Ash.Error.Filter.InvalidFilterValue","type":"exception"},{"doc":"Used when authorization for an action fails","ref":"Ash.Error.Forbidden.html","title":"Ash.Error.Forbidden","type":"exception"},{"doc":"Used when an unknown/generic framework error occurs","ref":"Ash.Error.Framework.html","title":"Ash.Error.Framework","type":"exception"},{"doc":"Used when an internal framework error occurs. These are always bugs.","ref":"Ash.Error.FrameworkError.html","title":"Ash.Error.FrameworkError","type":"exception"},{"doc":"The top level invalid error","ref":"Ash.Error.Invalid.html","title":"Ash.Error.Invalid","type":"exception"},{"doc":"Used when an invalid limit is provided","ref":"Ash.Error.InvalidLimit.html","title":"Ash.Error.InvalidLimit","type":"exception"},{"doc":"Used when an invalid offset is provided","ref":"Ash.Error.InvalidOffset.html","title":"Ash.Error.InvalidOffset","type":"exception"},{"doc":"Used when a resource or alias is provided that doesn't exist","ref":"Ash.Error.NoSuchResource.html","title":"Ash.Error.NoSuchResource","type":"exception"},{"doc":"Used when a resource's DSL is incorrectly configured.","ref":"Ash.Error.ResourceDslError.html","title":"Ash.Error.ResourceDslError","type":"exception"},{"doc":"Used when an invalid query is provided in a side load","ref":"Ash.Error.SideLoad.InvalidQuery.html","title":"Ash.Error.SideLoad.InvalidQuery","type":"exception"},{"doc":"Used when attempting to side load a relationship that does not exist","ref":"Ash.Error.SideLoad.NoSuchRelationship.html","title":"Ash.Error.SideLoad.NoSuchRelationship","type":"exception"},{"doc":"Used when an invalid sort order is provided","ref":"Ash.Error.Sort.InvalidSortOrder.html","title":"Ash.Error.Sort.InvalidSortOrder","type":"exception"},{"doc":"Used when attempting to sort on a field that does not exist","ref":"Ash.Error.Sort.NoSuchField.html","title":"Ash.Error.Sort.NoSuchField","type":"exception"},{"doc":"Used when attempting to sort on a field that cannot be used for sorting","ref":"Ash.Error.Sort.UnsortableField.html","title":"Ash.Error.Sort.UnsortableField","type":"exception"},{"doc":"The top level unknown error container","ref":"Ash.Error.Unknown.html","title":"Ash.Error.Unknown","type":"exception"}]